/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function ASSERT_ReportFormatter		//<c><a>public<d>Report formatter class
(){
//================
this.ASSERT_ReportFormatter = function		//<m>void<a>private<d>class constructor
(){
this.className	= 'ASSERT_ReportFormatter';
}//</m>ASSERT_ReportFormatter


//================
this.setWithTag = function		//<m>string<a>protected<d>
(
content,		//<p>string<d>Report content
hidding			//<p>boolean<d>Show tag flag: show || hide --optional
){
if(hidding) return content;
content = content.replace(/</g, '&lt;');
content = content.replace(/>/g, "&gt;");
return content;
}//</m>setWithTag


//================
this.getFormat = function		//<m>string<a>protected<d>
(
failure,	//<p>ASSERT_Failure<d>
stat		//<p>ASSERT_ReportStat<d>null if no id:comment for this failure/warning
){
return this.getSource(failure, stat) + this.getFailure(failure);
}//</m>getFormat


//================
this.getSource = function		//<m>string<a>private<d>
(
failure,	//<p>ASSERT_Failure<d>
stat		//<p>ASSERT_ReportStat<d>null if no id:comment for this failure/warning
){
return (stat==null) ? '' : this.getStampText() + this.getSourceText(failure, stat);
}//</m>getSource


//================
this.getFailure = function		//<m>string<a>private<d>
(
failure	//<p>ASSERT_Failure<d>
){
return failure.isWarning() ? this.getWarningText(failure) : this.getFailureText(failure);
}//</m>getFailure


//================
this.getSourceText = function		//<m>string<a>private<d>
(
failure,	//<p>ASSERT_Failure<d>
stat		//<p>ASSERT_ReportStat<d>null if no id:comment for this failure/warning
){
return sprintf(SOURCE_TEMPLATE, stat.getChecked(), stat.getFailed(), failure.getCaller(), failure.getSource());
}//</m>getSourceText


//================
this.getStampText = function		//<m>string<a>private<d>
(){
return sprintf(STAMP_TEMPLATE, this.getStamp());
}//</m>getStampText


//================
this.getStamp = function		//<m>string<a>public<d>
(){
var
/*date*/now = new Date(),
/*int*/millisec = now.getMilliseconds();
if(millisec < 100) millisec = '0' + millisec;
return sprintf('%s-%s-%s @%s:%s:%s&#160;&#160;.%s',
	this.setLeadingZero(now.getDate()),
	this.setLeadingZero(now.getMonth()+1),
	now.getFullYear(),
	this.setLeadingZero(now.getHours()),
	this.setLeadingZero(now.getMinutes()),
	this.setLeadingZero(now.getSeconds()),
	this.setLeadingZero(millisec));
}//</m>getStamp


//================
this.setLeadingZero = function		//<m>string<a>private<d>
(
value		//<p>int<d>Value to format
){
var
/*string*/lead = (value < 10) ? '0' : '';
return lead + value;	///cast value to string if it's not
}//</m>setLeadingZero


//================
this.getFailureText = function		//<m>string<a>private<d>
(
failure		//<p>ASSERT_Failure<d>
){
return sprintf(FAILURE_TEMPLATE, failure.getExpected(), failure.getFound(), failure.getComment());
}//</m>getFailureText


//================
this.getWarningText = function		//<m>string<a>private<d>
(
failure		//<p>ASSERT_Failure<d>
){
return sprintf(WARN_TEMPLATE, failure.getExpected(), this.setWithTag(failure.getComment()));
}//</m>getWarningText



const
/*string*/
STAMP_TEMPLATE =
'<div class="stamp">%s</div>\n',
SOURCE_TEMPLATE =
'<div class="source"><div class="stat">&#160;ASSERTIONS checked :<span class="checked">&#160;%s&#160;</span>failed :<span class="failed">&#160;%s&#160;</span></div><span class="source">%s</span><br/><span class="path">%s</span></div>\n',
FAILURE_TEMPLATE =
'<div class="failure">expected:<span class="expected">&#160;%s&#160;</span>found:<span class="found">&#160;%s&#160;</span><span class="comment">%s</span></div>\n',
WARN_TEMPLATE =
'<div class="warn"><span class="warn">&#160;%s&#160;</span>&#160;%s&#160;</div>\n';



this.ASSERT_ReportFormatter();
}//</c>ASSERT_ReportFormatter



