/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
__IMPORT__
	(
	'chrome://mozlib/content/lib/js/assert/',
	'formatter.js',
	'listener.js',
	'viewer.js'
	);



//@@@@@@@@@@@@@@@@
function ASSERT_Reporter		//<c><a>public<d>Assertion reporter class
(
_iframeId		//<p>string<d>Test iframe ID
){
//================
this.ASSERT_Reporter = function		//<m>void<a>private<d>class constructor
(
iframeId		//<p>string<d>Test iframe ID
){
this.className	= 'ASSERT_Reporter';
this.iframeId	= iframeId;
this.set_ASSERT_Reporter();
}//</m>ASSERT_Reporter



//================
this.set_ASSERT_Reporter = function		//<m>void<a>private<d>Instance i12n
(){
this.viewer = new ASSERT_ReportViewer(this.iframeId);
this.setClear();
}//</m>set_ASSERT_Reporter



//================
this.setClear = function		//<m>void<a>protected<d>
(){
this.stop		= false;
this.checked	= 0;
this.failed		= 0;
this.overall	= 0;
this.reported	= 0;
this.failures	= [];
this.viewer.setClear();
}//</m>setClear



//================
this.setFailure = function		//<m>void<a>protected<d>
(
failure		//<p>ASSERT_Failure<d>Failure
){
this.setFailed(failure);
failure.setStat(new ASSERT_ReportStat(this.checked, this.failed));
this.failures.push(failure);
}//</m>setFailure



//================
this.setChecked = function		//<m>void<a>private<d>
(){
this.checked++;
}//</m>setChecked



//================
this.setFailed = function		//<m>void<a>private<d>
(
failure		//<p>ASSERT_Failure<d>Failure
){
this.overall++;
if(failure.isWarning()) return;
this.failed++;
}//</m>setFailed



//================
this.setEnd = function		//<m>void<a>public<d>
(){
this.stop = true;
}//</m>setEnd



//================
this.setViewer = function		//<m>void<a>private<d>
(
content		//<p>string<d>Viewer content
){
this.viewer.setDisplay(content);
}//</m>setViewer



//================
this.getFailures = function		//<m>ASSERT_Failure[]<a>protected<d>
(){
if(this.hasNotReported()){
	var
	/*int*/atLevel = this.reported;
	this.reported = this.overall;		///clear
	return this.failures.slice(atLevel);
	}
return null;
}//</m>getFailures



//================
this.getContent = function		//<m>void<a>public<d>Get content
(){
return this.viewer.getContent();
}//</m>getContent



//================
this.isEndReport = function		//<m>boolean<a>protected<d>
(){
return this.stop;
}//</m>isEndReport



//================
this.hasNotReported = function		//<m>(boolean)int<a>private<d>
(){
return this.overall - this.reported;
}//</m>hasNotReported



this.ASSERT_Reporter(_iframeId);
}//</c>ASSERT_Reporter

