/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function DOM_Monitor		//<c><a>public<d>DOM monitor class to create and modify DOM elements
(
_xuldocument		//<p>Object<d>XUL document object
){
//================
this.DOM_Monitor = function		//<m>void<a>private<d>class constructor
(
xuldocument		//<p>Object=window<d>XUL document object --optional
){
this.document = xuldocument || window.document;
}//</m>DOM_Monitor



//================
this.setNewElement = function		//<m>void<a>public<d>create a new element as a child of a specified node
(
name,			//<p>string<d>element tag
attributes,		//<p>string{]<d>argument list for attributes --optional (attribute underscore char replaced by hiphen)
parentId		//<p>string<d>created element parent ID --optional
){
var
newElement = this.document.createElement(name);
if(attributes) for(var at in attributes) newElement.setAttribute((at == 'klass') ? 'class' : at.replace(/_/g, '-'), attributes[at]);	//declare object property class for CSS
if(parentId) this.setChild(parentId, newElement);
return newElement;
}//</m>setNewElement<d>&
/*
To get an attribute name containing hyphen chars (JavaScript minus sign) use underscore chars
(background-color == background_color)
To get a class attribute (JavaScript keyword) use klass
*/



//================
this.setChild = function		//<m>void<a>public<d>Append child node to its parent
(
parent,			//<p>string<d>Parent element node or ID
child			//<p>string<d>Child element node
){
if(typeof parent == 'string') parent = this.getElement(parent);
parent.appendChild(child);
}//</m>setChild



//================
this.setAttribute = function		//<m>void<a>public<d>Setup attribute of element
(
elementId,		//<p>string<d>element ID
at,				//<p>string<d>Element attribute name
value			//<p>string<d>Attribute value to setup
){
this.getElement(elementId).setAttribute(at, value);
}//</m>setAttribute



//================
this.setNewTextElement = function		//<m>void<a>public<d>create a new text element as a child of a specified node
(
parent,			//<p>string<d>created element parent node or ID
text			//<p>string<d>element text
){
this.setChild(parent, this.document.createTextNode(text));
}//</m>setNewElement



//================
this.setRemoveContent = function		//<m>void<a>public<d>Remove children of an element
(
ownerId		//<p>string<d>Element node ID
){
var
owner = this.getElement(ownerId);
if(!owner.hasChildNodes()) return;
var
children = owner.childNodes;
for(var i=0,m=children.length;i<m;i++) owner.removeChild(children.item(i));
}//</m>setRemoveContent



//================
this.getElement = function		//<m>Object<a>public<d>get the node of an element from its ID
(
elementId		//<p>string<d>element ID
){
return this.document.getElementById(elementId);
}//</m>getElement



//================
this.getAttribute = function		//<m>void<a>public<d>Get attribute of element
(
elementId,		//<p>string<d>element ID
at				//<p>string<d>Element attribute name
){
return this.getElement(elementId).getAttribute(at);
}//</m>getAttribute



//================
this.getSetWithAttribute = function		//<m>Object<a>public<d>get nodes of elements from a common attribute value
(
at,		//<p>string<d>Attribute
value	//<p>string<d>Attribute value
){
return this.document.getElementsByAttribute(at, value);
}//</m>getSetWithAttribute



//================
this.getSetWithTag = function		//<m>Object<a>public<d>get nodes of elements from a common attribute value
(
tag		//<p>string<d>Tag name
){
return this.document.getElementsByTagName(tag);
}//</m>getSetWithTag



this.DOM_Monitor(_xuldocument);
}//</c>DOM_Monitor



