/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function ERROR_Notifier		//<c><a>public<d>Error notifier class
(
_referrer,		//<p>string<d>Referrer class name
_output			//<p>int<d>Output notification code
){
//================
this.ERROR_Notifier = function		//<m>void<a>private<d>class constructor
(
referrer,		//<p>string<d>Referrer class name
output			//<p>int<d>Output notification code
){
this.className	= 'ERROR_Notifier';
this.referrer	= referrer;
this.output		= output || this.K.DUMP_OUTPUT;
this.setIn();
}//</m>ERROR_Notifier



//================
this.setIn = function		//<m>void<a>private<d>Instance i12n
(){
if(this.output != this.K.JSCONSOLE_OUTPUT){
	this.stdout = new STDOUT_Controller();
	return;
	}
if(this.output != this.K.JSCONSOLE_OUTPUT) return;
try{
	this.service = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
	}
catch(e){
	this.service = null;
	}
}//</m>setIn



//================
this.setOut = function		//<m>int<a>public<d>Output the error according to output method
(
note,		//<p>string<d>Notification message
code		//<p>int<d>Notification code
){
var
/*string*/out = '[ ' + this.referrer + ' ] ( ' + code + ' )' + (this.output ? '\n' : ' ') + note  + '\n';
switch(this.output){
	case this.K.ALERT_OUTPUT:
		window.alert(out);
		break;
	case this.K.CONFIRM_OUTPUT:
		window.confirm(out);
		break;
	case this.K.JSCONSOLE_OUTPUT:
		if(this.service) this.service.logStringMessage(out);
		break;
	default:	//DUMP_OUTPUT
		this.stdout.setOut('[ %s ] ( %s ) %N', this.referrer, code, note);
		//dump(out);
	}	//---switch
return code;
}//</m>setOut



//================
this.set_output = function		//<m>int<a>public<d>Set up output notification
(
output		//<p>int<d>Output method
){
this.output = output;
}//</m>set_output



this.K =
	{
	DUMP_OUTPUT:			0,
	ALERT_OUTPUT:			1,
	CONFIRM_OUTPUT:			2,
	JSCONSOLE_OUTPUT:		3
	};



this.ERROR_Notifier(_referrer, _output);
}//</c>ERROR_Notifier




