/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function STDOUT_Controller		//<c><a>public<d>Console output controller class
(
_formatter		//<p>Object<d>Formatting descriptor object
){
//================
this.STDOUT_Controller = function		//<m>void<a>private<d>class constructor
(
formatter		//<p>Object<d>Formatting descriptor object
){
this.className	= 'STDOUT_Controller';
this.formatter	= formatter;
this.setIn();
}//</m>STDOUT_Controller



//================
this.setIn = function		//<m>void<a>private<d>Instance i12n
(){
if(!this.formatter){
	this.formatter =
		{
		escapeChar: '%',
		s: function(target, arg){return target + arg},					//simply concatenate
		d: function(target, arg){return target + parseFloat(arg)},		//as number
		T: function(target, arg){return target + arg + '\t'},			//add a tab after arg
		U: function(target, arg){return target + '\t' + arg},			//add a tab before arg
		N: function(target, arg){return target  + arg + '\n'},			//append a newline
		R: function(target, arg){return target + '\t' + arg + '\n'}		//add a tab between target and arg and append a newline
		};
	}
this.splitter = this.getSplitter();
this.dumping = true;
}//</m>setIn



//================
this.set_formatter = function		//<m>void<a>public<d>Setup formatter member
(
formatter		//<p>Object<d>Formatting descriptor object
){
this.formatter = formatter;
}//</m>set_formatter<d>&
/*
Default formatter member can be overwritten, calling this method from any client object, at any time
*/



//================
this.set_dumping = function		//<m>void<a>public<d>Setup dumping member
(
dumping		//<p>boolean<d>Dumping flag: dump to stdout || no dump
){
this.dumping = dumping;
}//</m>set_dumping



//================
this.setOut = function		//<m>string<a>private<d>Output to stdout
(
//arguments
){
var
/*string[]*/argSet = [];
for(var i=0,m=arguments.length;i<m;i++) argSet[i] = arguments[i];
var
/*/*string*/out = this.getOutput(argSet);
if(this.dumping) dump(out);
return out;
}//</m>setOut



//================
this.getSplitter = function		//<m>void<a>private<d>Build splitter member RegExp
(){
var
/*string*/charset = '';
for(var k in this.formatter) if((typeof this.formatter[k]) == 'function') charset += k;
var
/*string*/splitter = this.formatter.escapeChar + '[' + charset + ']';
return new RegExp(splitter, 'g');
}//</m>getSplitter



//================
this.getOutput = function		//<m>void<a>private<d>Output budder to stdout
(
argSet			//<p>string[]<d>Output arguments
){
try{
	var
	/*string*/	output		= '',
	/*string*/	format		= argSet.shift(),
	/*string[]*/charSet		= format.match(this.splitter),
	/*string[]*/targetSet	= format.split(this.splitter);
	for(var i=0,m=argSet.length;i<m;i++) output += this.formatter[charSet[i].charAt(1)](targetSet[i], argSet[i]);
	output += targetSet[targetSet.length -1];		//append trailing target string
	}
catch(e){
	output = '\nINVALID ARGUMENTS for STDOUT_Controller\n' + e;
	}
return output;
}//</m>getOutput



this.STDOUT_Controller(_formatter);
}//</c>STDOUT_Controller


var
Stdout	= new STDOUT_Controller();

