/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function ERROR_Tracer		//<c><a>public<d>JavaScript stack tracer class
(
_header,	//<p>string<d>Trace report header
_format		//<p>string<d>Stack line format
){
//================
this.ERROR_Tracer = function		//<m>void<a>private<d>class constructor
(
header,		//<p>string<d>Trace report header
format		//<p>string<d>Stack line format
){
this.className	= 'ERROR_Tracer';
this.header		= header || this.K.TRACE_HEADER;
this.format		= format || this.K.FRAME_FORMAT;
this.setIn();
}//</m>ERROR_Tracer



//================
this.setIn = function		//<m>void<a>private<d>Instance i12n
(){
this.errorNotifier	= new ERROR_Notifier(this.className);
this.trace			= '';
}//</m>setIn



//================
this.set_trace = function		//<m>string<a>public<d>Set up stack trace report
(
exception,		//<p>string<d>Exception thrown (or any text) --optional
traceStop		//<p>string<d>Calling function name where to stop tracing --optional
){
try{
	traceStop = traceStop || null;
	var
	/*Object*/frame = Components.stack.caller.caller.caller,		//skip mediator and api stack frames -- nsIXPCComponents
	/*string*/trace = (exception || '') + this.K.TRACE_HEADER;
	while(frame != null){
		trace += this.getFrame(frame);
		if(frame.name == traceStop) break;
		frame = frame.caller;
		}
	this.trace = trace;
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.STACK_TRACE);
	this.trace = '';
	}
}//</m>set_trace



//================
this.get_trace = function		//<m>string<a>public<d>Get stack trace report
(){
var
/*string*/trace = this.trace;
this.trace = '';	//clear
return trace;
}//</m>get_trace



//================
this.getFrame = function		//<m>string<a>private<d>Get stack frame properties
(
frame		//<p>Object<d>Stack frame
){
return sprintf(this.K.FRAME_FORMAT, frame.name, frame.filename, frame.lineNumber);
}//</m>getFrame



this.K =
	{
	TRACE_HEADER:		'\n\nSTACK TRACE\n',
	FRAME_FORMAT:		'[function: %s] [source: %s] [line: %s]\n',

	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		STACK_TRACE:			-1,
		FATAL:					0xFF		//end of error codes
		}
	};



this.ERROR_Tracer(_header, _format);
}//</c>ERROR_Tracer<d>&
/*
_format class parameter must have 3 placeholders (%s):
1. source file name,
2. line number,
3. command name
*/



