/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function IO_file_Accessor		//<c><a>protected<d>File accessor class
(){
//================
this.IO_file_Accessor = function		//<m>void<a>private<d>class constructor
(){
this.className		= 'IO_file_Accessor';
this.setIn();
}//</m>IO_file_Accessor



//================
this.setIn = function		//<m>void<a>private<d>Instance i12n
(){
this.errorNotifier = new ERROR_Notifier(this.className);
}//</m>setIn



//================
this.set_permissions = function		//<m>int<a>protected<d>Setup permissions member
(
permissions		//<p>int=0644<d>Permission code --optional
){
this.permissions = permissions ||
	(this.type == this.K.FILE_INSTANCE) ? this.K.DEFAULT_FILE_PERMS :
		this.K.DEFAULT_DIR_PERMS;
}//</m>set_permissions



//================
this.set_type = function		//<m>void<a>protected<d>Get permissions member
(
type		//<p>int=0<d>Type code
){
this.type = type;
}//</m>set_type



//================
this.get_permissions = function		//<m>int<a>protected<d>Get permissions member
(){
return this.permissions;
}//</m>get_permissions



//================
this.get_type = function		//<m>int<a>protected<d>Get type member
(){
return this.type;
}//</m>get_type



//================
this.testEntity = function		//<m>boolean<a>protected<d>Check this entity against the specified type
(
entity		//<p>string<d>Entity type to compare with --optional (exists)
){
switch(entity){
	case 'file':	return this.handle.isFile();
	case 'dir':		return this.handle.isDirectory();
	case 'link':	return this.handle.isSymlink();
	case 'hidden':	return this.handle.isHidden();
	default:		return this.handle.exists();
	}	//---switch
}//</m>testEntity



//================
this.testMode = function		//<m>boolean<a>protected<d>Check whether a specific mode is allowed
(
mode		//<p>int<d>Access mode: XX_MODE constant
){
switch(mode){
	case 'r':	return this.handle.isReadable();
	case 'w':	return this.handle.isWritable();
	case 'x':	return this.handle.isExecutable();
	default:	return false;
	}	//---switch
}//</m>testMode



this.K =
	{
	FILE_INSTANCE:				0,		//synchronise with XPCOM_nsIFile NORMAL_FILE_TYPE
	DIR_INSTANCE:				1,		//synchronise with XPCOM_nsIFile DIRECTORY_TYPE
	DEFAULT_FILE_PERMS:			0644,	//rw-r--r--
	DEFAULT_DIR_PERMS:			0755,	//rwxr-xr-x
	READABLE_MODE:				'r',
	WRITABLE_MODE:				'w',
	EXECUTABLE_MODE:			'x',
	PR_RDONLY:					0x01,
	PR_WRONLY:					0x02,
	PR_RDWR:					0x04,
	PR_CREATE_FILE:				0x08,
	PR_APPEND:					0x10,		//OR WITH PR_WRONLY || PR_RDWR
	PR_TRUNCATE:				0x20,
	PR_SYNC:					0x40,
	PR_EXCL:					0x80,		//With PR_CREATE_FILE, if the file already exist, no action and NULL is returned
	WRITE_APPEND:				0x12,
	
	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		READ_MODE_ACCESS:		-2,
		WRITE_MODE_ACCESS:		-3,
		EXEC_MODE_ACCESS:		-4,
		//SPECIAL_MODE_ACCESS:	-5,
		FATAL:					0xFF		//end of error codes
		}
	};



this.IO_file_Accessor();
}//</c>IO_file_Accessor<d>&
/*
This component class manages handled file/dir permissions
*/



