/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function IO_file_DirDescriptor		//<c><a>protected<d>File controller class
(
_itemSet			//<p>Object<d>Content enumerator
){
//================
this.IO_file_DirDescriptor = function		//<m>void<a>private<d>class constructor
(
itemSet				//<p>Object<d>Content enumerator
){
this.className		= 'IO_file_DirDescriptor';
this.setIn(itemSet);
}//</m>IO_file_DirDescriptor



//================
this.setIn = function		//<m>void<a>private<d>Instance i12n
(
itemSet			//<p>Object<d>Content enumerator
){
this.errorNotifier = new ERROR_Notifier(this.className);
for(var k in itemSet){
	this[k] = itemSet[k];		//this.fileHandleSet,		this.dirHandleSet
	this.setIndices(k);			//this.fileHandleIndexSet,	this.dirHandleIndexSet
	}
}//</m>setIn



//================
this.setIndices = function		//<m>void<a>private<d>Setup fileHandleIndexSet/dirHandleIndexSet member
(
member		//<p>string<d>Class member name
){
var
/*int*/i = 0,
/*string*/indexSet = member.replace(/Set/, 'IndexSet');
/*string[]*/this[indexSet] = [];
for(var k in this[member]) this[indexSet][i++] = k;
}//</m>setIndices<d>&
/*
item handles are accessible either by:
path key:	this.fileHandleSet[path] == XPCOM_nsIFile object
index:		this.dirHandleSet[this.dirHandleIndexSet[i]] == XPCOM_nsIFile object
*/



//================
this.getIterating = function		//<m>int<a>public<d>Get each item in fileSet/dirSet applying the specified function
(
type,		//<p>int<d>File object type: file || directory --optional
callback	//<p>function<d>Function to call back at each step
){
var
/*string*/collectionKey, collectionIndex;
if(type){
	collectionKey	= 'dirHandleSet';
	collectionIndex	= 'dirHandleIndexSet';
	}
else{
	collectionKey	= 'fileHandleSet';
	collectionIndex	= 'fileHandleIndexSet';
	}
try{
	for(var i=0,m=this[collectionIndex].length;i<m;i++) callback(i, this[collectionKey][this[collectionIndex][i]]);
	return this.K.ERROR.NONE;
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.COLLECTION_ITERATING);
	}
return this.K.ERROR.COLLECTION_ITERATING;
}//</m>getIterating



//================
this.getCollectionLength = function		//<m>int<a>public<d>Get fileSet/dirSet capacity
(
type		//<p>int<d>File object type: file || directory --optional
){
return type ? this.dirHandleIndexSet.length : this.fileHandleIndexSet.length;
}//</m>getCollectionLength



//================
this.getItemAt = function		//<m>int<a>public<d>Get the file/dir handle at specified index
(
at		//<p>int<d>Index of item
){
return type ? this.dirHandleSet[this.dirHandleIndexSet[at]] : this.fileHandleSet[this.fileHandleIndexSet[at]];
}//</m>getItemAt



//================
this.testEntity = function		//<m>boolean<d>public<d>Check whether a file/dir is present in this directory
(
path,		//<p>string<d>File object path
type		//<p>int<d>File object type: file || directory --optional
){
return type ? (path in this.dirHandleSet) : (path in this.fileHandleSet);
}//</m>testEntity



this.K =
	{

	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		COLLECTION_ITERATING:	-1,
		FATAL:					0xFF		//end of error codes
		}
	};



this.IO_file_DirDescriptor(_itemSet);
}//</c>IO_file_DirDescriptor<d>&
/*
ContentSet class argument:
	{
	fileHandleSet:	Object[]	//keys are file path, values are file handles
	dirHandleSet:	Object[]	//keys are dir path, values are dir handles	
	}
*/



