/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
var
/*Object*/LANG_const_Default =
	{
	ERROR:
		{
		//NON FATAL
		NONE:				0,
		NO_SUCCESS:			1,
		//FATAL             
		FATAL:				0xffff
		}
	};


//@@@@@@@@@@@@@@@@
function LANG_const_Collector		//<c><a>public<d>Constants definition class
(
_constantSet		//<p>const[]<d>Constant definition set
){
//================
this.LANG_const_Collector = function		//<m>void<a>private<d>class constructor
(
constantSet		//<p>const[]<d>Constant definition set
){
this.className	= 'LANG_const_Collector';
//i12n
if(constantSet) this.setConst(constantSet);
if(!constantSet || !('ERROR' in constantSet)) this.setConst(LANG_const_Default);
}//</m>LANG_const_Collector



//================
this.setConst = function		//<m>string[]<a>public<d>Set up constants
(
constantSet,		//<p>const[]<d>Constant definition set
preserving			//<p>boolean=false<d>Previous definition preserving flag: preserve || overwrite
){
try{
	for(var k in constantSet) if(!preserving) this[k] = constantSet[k];
	}
catch(e){
	/****************DEBUG***************/
	Stdout.setOut('####EXCEPTION: %N', e);
	/****************DEBUG***************/
	}
}//</m>setConst



//================
this.setConstSet = function		//<m>string[]<a>public<d>Add constants to an already defined constantSet
(
constantSet,		//<p>const[]<d>Constant definition set
preserving			//<p>boolean=false<d>Previous definition preserving flag: preserve || overwrite
){
try{
	for(var k in constantSet){
		if(!(k in this)) this[k] = [];		//create subset
		for(var l in constantSet[k]) if(!preserving) this[k][l] = constantSet[k][l];
		}	//---for in
	}
catch(e){
	/****************DEBUG***************/
	Stdout.setOut('####EXCEPTION: %N', e);
	/****************DEBUG***************/
	}
}//</m>setConstSet<d>&
/*
Acts has setConst method at a sublevel of the constant set
*/



//================
this.setOut = function		//<m>string<a>public<d>Instance inspection
(){
var
/*string*/out = '';
for(var k in this) if(typeof(this[k]) != 'function'){
	out += sprintf('[%s] %s\n', k, this[k]);
	if(typeof(this[k]) == 'object'){
		for(var l in this[k]) if(typeof(this[k][l]) != 'function') out += sprintf('\t[%s] %s\n', l, this[k][l]);
		}
	}
return out;
}//</m>setOut



this.LANG_const_Collector(_constantSet);
}//</c>LANG_const_Collector

