/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function RDFAPI_Node		//<c><e>RDFAPI_NSRDF<a>protected<d>RDF node class
(
_source		//<p>Object<d>Resource node or URN or literal
){
const ASSERTING = false;
//================
this.RDFAPI_Node = function		//<m>void<a>private<d>class constructor
(
source			//<p>Object<d>Resource node or URN or literal
){
this.prototype = RDFAPI_NSRDF;
this.prototype();
this.className	= 'RDFAPI_Node';
this.set_source(source);
//i12n
this.registered	= false;
this.type		=			//set up in subclasses
this.node		= null;
}//</m>RDFAPI_Node



//================
this.set_source = function		//<m>int<a>private<d>Set up the source member
(
source				//<p>Object<d>Resource node or URN or literal
){
this.source = source;
}//</m>set_source



//================
this.set_registered = function		//<m>Object<a>public<d>Set up registered member
(
registering		//<p>boolean<d>Registering in model flag: registered || not registered
){
this.registered = registering;
}//</m>set_registered



//================
this.getAsNode = function		//<m>Object<a>public<d>Cast a nsIRDFResource || nsIRDFLiteral to a nsIRDFNode
(){
return this.getInterface('nsIRDFNode');
}//</m>getAsNode



//================ FIXME: remove ???
this.testNodeType = function		//<m>boolean<a>private<d>Check whether the node is a Resource or a Literal
(){
return this.type < this.K.rsc.STRING_LITERAL_NODE;
}//</m>testNodeType




//================
this.testEquality = function		//<m>boolean<a>public<d>Check whether the resource is the same as  this one
(
node,		//<p>Object<d>Node to compare
type		//<p>Object<d>Type of node to compare
){
try{
	//__ASSERT__.warn('testEquality: node == ' + node.Value, ASSERTING);
	//__ASSERT__.isTrue(this.node.EqualsNode((node instanceof type) ? node.source : node), ASSERTING, 'testEquality: EqualsNode == ');
	return this.node.EqualsNode((node instanceof type) ? node.source : node);
	}
catch(e){
	//Stdout.setOut('EXCEPTION: %N', e);
	return false;
	}
}//</m>testEquality


//================
this.testPattern = function		//<m>boolean<a>public<d>Check whether the resource matches a RegExp pattern
(
pattern	//<p>Object<d>RegExp pattern
){
try{
	//__ASSERT__.warn('testPattern: node value == ' + this.node.Value, ASSERTING);
	//__ASSERT__.warn('testPattern: match == ' + this.node.Value.match(pattern), ASSERTING);
	return this.node.Value.match(pattern) != null;
	}
catch(e){
	//Stdout.setOut('EXCEPTION: %N', e);
	return false;
	}
}//</m>testPattern


this.RDFAPI_Node(_source);
}//</c>RDFAPI_Node

