/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function RDFAPI_Resource		//<c><a>protected<d>RDF resource class
(
_source,			//<p>Object<d>Resource node or URN
_type				//<p>int<d>Resource type: nsINode or nsIResource or string (URI)
){
const ASSERTING = false;
//================
this.RDFAPI_Resource = function		//<m>void<a>private<d>class constructor
(
source,				//<p>Object<d>Resource node or URN
type				//<p>int<d>Resource type: INSTANCE_ || NODE_ || NAMED_ || ANONYMOUS_
){
this.prototype = RDFAPI_Node;
this.prototype(source);
this.className	= 'RDFAPI_Resource';
//i12n
this.set_type(type);
this.set_node();
}//</m>RDFAPI_Resource



//================
this.set_type = function		//<m>void<a>private<d>Set up the type member according to its source type
(
type				//<p>int<d>Resource type: nsINode or nsIResource or string (URI)
){
this.type = type;
//__ASSERT__.warn('RDFAPI_Literal.set_type: this.source == ' + this.source, ASSERTING);
//__ASSERT__.warn('RDFAPI_Literal.set_type: typeOf this.source == ' + LANG_object_getType(this.source), ASSERTING);
//__ASSERT__.warn('RDFAPI_Literal.set_type: this.type == ' + this.type, ASSERTING);
}//</m>set_type



//================
this.set_node = function		//<m>(boolean)int<a>private<d>Set up node member accroding to its type
(){
var
/*string*/method;
switch(this.type){
	case 0:		//INSTANCE_RESOURCE
		this.node = this.source;		//this.source is already an nsIResource
		break;
	case 3:		//ANONYMOUS_RESOURCE	//FIXME: use MD5 hash?
		method = 'GetAnonymousResource';
		break;
	//case 1:	NODE_RESOURCE
	//case 2:	NAMED_RESOURCE
	default:
		method = 'GetResource';
		break;		
	}	//---switch
try{
	if(method) this.node = this.XPCOM_RDFService[method](this.source);
	if(this.type == this.K.rsc.NODE_RESOURCE) this.node = this.getAsNode();
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.SERVICE_ACCESS);
	}
}//</m>set_node



//================ //REFACTOR: name was getValue
this.getURI = function		//<m>string<a>public<d>Get the value of the resource
(){
try{
	return this.getAsNode().Value;
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.UNVAILABLE_INTERFACE);
	return '';
	}
}//</m>getURI<d>&
/*
RDF API
*/



//================
this.getAsResource = function		//<m>Object<a>public<d>Cast a nsIRDFNode to a nsIRDFResource
(){
return this.getInterface('nsIRDFResource');
}//</m>getAsResource



//================ FIXME ???? DO WE NEED
this.getResource = function		//<m>Object<a>public<d>Cast a nsIRDFNode to a nsIRDFResource
(){
//return (this.testNodeType()) ? this.getAsResource() : this.getAsNode();
}//</m>getResource



//================
this.getNamespace = function		//<m>string<a>public<d>Get namespace
(){
var
/*string*/uri = this.getURI(),
at = uri.indexOf(':');
return (at != -1) ? uri.substr(0, at) : '';
}//</m>getNamespace<d>&
/*
RDF API
We assume than any URI begining with a chain and a colon denotes a namespaced URI
Chain preceding the 1st colon is then the namespace prefix
*/



//================
this.getLocalName = function		//<m>string<a>public<d>Get local name
(){
var
/*string*/uri = this.getURI(),
at = uri.indexOf(':');
return (at != -1) ? uri.substr(at+1) : uri;
}//</m>getLocalName<d>&
/*
RDF API
We assume than any URI begining with a chain and a colon denotes a namespaced URI
Chain following the 1st colon is then the namespace prefix
*/



//================
this.testBNode = function		//<m>(boolean)string<a>public<d>Check whether the resource is a blank node (anonymous)
(){
try{
	return this.XPCOM_RDFService.IsAnonymousResource(this.node);
	}
catch(e){
	return null;
	}
}//</m>testBNode



this.RDFAPI_Resource(_source, _type);
}//</c>RDFAPI_Resource

