/*
 * The contents of this file are
 * Copyright (C) 2003 ID EST. All Rights Reserved.
 */
//@@@@@@@@@@@@@@@@
function UTILS_TreeNode		//<c><a>public<d>Tree class
(
_id,		//<p>string<d>Node identifier
_type	//<p>int<d>Node type
){
//================
this.UTILS_TreeNode = function		//<m>void<a>private<d>class constructor
(
id,		//<p>string<d>Node identifier
type	//<p>int<d>Node type
){
this.className	= 'UTILS_TreeNode';
this.id			= id;
this.type		= type;
//i12n
this.active		= ACTIVNODE;  	//(this.active==this) ? sibling actif : (null) sibling inactif
this.parent		=				//root node ? null : parent.id
this.previous	=				//root node || first sibling ? null : sibling.id
this.next		=			    //root node || last sibling ? null : sibling.id
this.first		=				//no child ? null : child.id
this.last		= null;		    //no child ? null : child.id
        //ALTERNODES si type == ALTERNODE
this.elder		=				//elder==alternative ? true : false
this.younger	= false;		//elder!=alternative ? true : false
this.children	= [];  			//index par id
this.index		= [];  			//index par number : id des children
this.descent	= [];  			//collection de tous les NODE descendants recueillis par this.collect()
}//</m>UTILS_TreeNode



//================
this.createChild = function		//<m>UTILS_TreeNode<a>public<d>Create a new node as a child of this one
(
id,		//<p>string<d>Node identifier
type	//<p>int<d>Node type
){
var
/*_NODE*/n = new _NODE(id,type);
this.children[id] = n;
this.index[this.index.length] = id;
n.parent = this;
if(this.last){
  this.last.next = n;
  n.previous = this.last;
  }  //if(i)
if(!this.first) this.first = n;
this.last = n;
if(type==NORMALNODE) return n;
  //ALTERNODE
if(n==this.first) n.elder = ELDERNODE;  //1er child =>ELDERNODE (reste activ)
else{
  n.younger = YOUNGERNODE;  //Neme child =>YOUNGERNODE (dsactiv)
  n.active = IDLENODE;
  }  //elseif(n==this.first)
return n;
}//</m>createChild



//================
this.appendChild = function		//<m>UTILS_TreeNode<a>public<d>Add a node as a last child of this one
(
node		//<p>UTILS_TreeNode<d>Node to append
){
this.children[n.id] = n;
this.index[this.index.length] = n.id;
n.parent = this;
if(this.last){
  this.last.next = n;
  n.previous = this.last;
  }  //if(i)
if(!this.first) this.first = n;
this.last = n;
if(n.type==NORMALNODE) return n;
  //ALTERNODE
if(n==this.first) n.elder = ELDERNODE  //1er child =>ELDERNODE (reste activ)
else{
  n.younger = YOUNGERNODE;  //Neme child =>YOUNGERNODE (dsactiv)
  n.active = IDLENODE;
  }  //elseif(n==this.first)
return n;  //le node ajout est retourn
}//</m>appendChild



//================
this.replaceChild = function		//<m>UTILS_TreeNode<a>public<d>Replace child node with id by node
(
id,			//<p>string<d>Identifier of replaced node
node		//<p>UTILS_TreeNode<d>Replacing node
){
var
r = this.children[id];
this.children[id] = n;
n.parent = this;
n.id = r.id;
n.previous = r.previous;
n.next = r.next;
if(this.first==r) this.first = n;
if(this.last==r) this.last = n;
if(n.type==NORMALNODE) return r;  //le node remplac est retourn
  //ALTERNODE
if(n==this.first) n.elder = ELDERNODE;  //1er child =>ELDERNODE (reste activ)
else{
  n.younger = YOUNGERNODE;  //Neme child =>YOUNGERNODE (dsactiv)
  n.active = IDLENODE;
  }
return r;
}//</m>replaceChild



//================
this.findChild = function		//<m>
(
id,		//<p>string<d>Node identifier
a		//<p>UTILS_TreeNode<d>
){
var
n,
j = this.index.length;
for(var i=0; i<j; i++){
  n = this.children[this.index[i]];
  if(n.index.length) n.findChild(id,a);
  if(n.id == id) a[a.length] = n;
  }
}//</m>findChild



//================
this.collect = function		//<m>UTILS_TreeNode[]<d>Collect all descendant of node (only active ones if isa)
(

){
var
n,
j = this.index.length;  //=>children
for(var i=0; i<j; i++){
  n = this.children[this.index[i]];
  if(n.index.length) n.collect(isa,a,it);
  if(isa && n.type==ALTERNODE && !n.active) return;
  a[(it==INAME) ? n.id : a.length] = n;  //a.length =>index array : n.id=>hash array
  }  //for
}//</m>collect



//================
this.invertactive = function		//<m>void<a>public<d>Desactivate active child to activ child with id
(
id		//<p>string<d>Node identifier
){
var
n,
d = 0,  //mis  1 ds que n.active est trouv
j = this.index.length;  //=>children
for(var i=0; !d && i<j; i++){
  n = this.children[this.index[i]];
  if(n.active){
    d = 1;  //n.actif trouv
    n.active = IDLENODE;
    }
  }  //for
this.children[id].active = ACTIVNODE;
}//</m>invertactive



this.K =
	{
	NORMAL_NODE:	0,
	ALTER_NODE:		1,  	//ALTERNODE : node formant une squence avec ses siblings
	OLDER_NODE:		true,
	YOUNGER_NODE:	true,    //1st sibling : other siblings
	ALL_NODES:		0,
	ACTIV_NODES:	1,		//recherche des nodes actifs seuls : this.collect()
	IDLE_NODE:		0,
	ACTIVE_NODE:	1,		//recherche des nodes actifs seuls : this.collect()
	INAME:			1       //indexation nominale (id) ou numrique : this.collect()
	};


this.UTILS_TreeNode(_id, _type);
}//</c>UTILS_TreeNode



