/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
var
XPConnector =		//<c><a>public<d>XPCOM server global variable (singleton)
{
K:	null,


//================
setUp: function		//<m>void<a>public<d>Setup the constant set array (K member)
(
constantSet		//<p>string<d>Constant set
){
if(!this.K) this.K = constantSet;
}//</m>setUp<d>&
/*
Method MUST be called only once to initialize K member with the set of interfaces used by client objects
*/
,


//================
getConstructor: function		//<m>Object<a>public<d>Get an XPCOM component constructor object
(
key,			//<p>string<d>Component key
initializer		//<p>function<d>Function to call to initialize the constructor --optional
){
try{
	return initializer ?
			Components.Constructor(this.getClasses(key), key, this.K[initializer]) :
			Components.Constructor(this.getClasses(key), key);		//DO NOT use a 3 args signature if initializer is undefined
	}
catch(e){
	return null;
	}
}//</m>getConstructor
,


//================
getClasses: function		//<m>Object<a>public<d>Get an XPCOM component object instance
(
key		//<p>string<d>Component key
){
var
/*string*/contractId = this.K[key],
/*Object[]*/classes = this.testMozId(contractId) ? Components.classes : Components.classesByID;
try{
	return classes[contractId];
	}
catch(e){
	return null;
	}
}//</m>getClasses
,


//================
getInstance: function		//<m>Object<a>public<d>Get an XPCOM component object instance
(
key		//<p>string<d>Component key
){
try{
	return this.getClasses(key).createInstance(this.getInterface(key));
	}
catch(e){
	return null;
	}
}//</m>getInstance
,


//================
getService: function		//<m>Object<a>public<d>Get an XPCOM component object service
(
key		//<p>string<d>Component key
){
try{
	return this.getClasses(key).getService(this.getInterface(key));
	}
catch(e){
	return null;
	}
}//</m>getService
,


//================
getInterface: function		//<m>Object<a>public<d>Get an XPCOM component interface object
(
key		//<p>string<d>Component key
){
try{
	return Components.interfaces[key];
	}
catch(e){
	return null;
	}
}//</m>getInterface
,


//================
getQuery: function		//<m>Object<a>public<d>Get an interface of an XPCOM object
(
key,		//<p>string<d>Component interface
xpcom		//<p>Object<d>XPCOM object to be queried
){
try{
	return xpcom.QueryInterface(this.getInterface(key));
	}
catch(e){
	return null;
	}
}//</m>getQuery
,


//================
testMozId: function		//<m>boolean<a>private<d>Check whether contract is in readable format (starting with @)
(
contractId		//<p>string<d>Check whether contractId is in readable (@mozilla...) or canonical form ({...})
){
return contractId.charAt(0) == '@';
}//</m>testMozId



}//</c>XPConnector

